% Compute the quantization matrix as a function of 'lvl' The output is an
% 8x8x3 matrix which is constant over the third index.
%
% TODO - it would be good to share this code with the monochrome jpeg example

function y = quant3(lvl)
  tbl = [ 16,  11,  10,  16,  24,  40,  51,  61
          12,  12,  14,  19,  26,  58,  60,  55
          14,  13,  16,  24,  40,  57,  69,  56
          14,  17,  22,  29,  51,  87,  80,  62
          18,  22,  37,  56,  68, 109, 103,  77
          24,  35,  55,  64,  81, 104, 113,  92
          49,  64,  78,  87, 103, 121, 120, 101
          72,  92,  95,  98, 112, 100, 103,  99 ];
  lvl = max(1, min(lvl, 100));
  if lvl < 50
    s = floor(5000 / lvl);
  else
    s = 200 - 2*lvl;
  end
  q = max(1, floor((tbl * s + 50) / 100));

  y = zeros(8,8,3);
  y(:,:,1) = q;
  y(:,:,2) = q;
  y(:,:,3) = q;
end
