% Convert YCbCr color to RGB color see https://en.wikipedia.org/wiki/YCbCr
%
% Precondition: 'x' is a YCbCr image, in particular size(x) = [r,c,3]

function z = ycbcr_to_rgb(x)

  [rows,cols,planes] = size(x);
  x = double(x);

  % z = zeros(rows,cols,3,'uint8');
  z = zeros(rows,cols,3);
  for i = 1:rows
    for j = 1:cols
      y  = x(i,j,1);
      cb = x(i,j,2);
      cr = x(i,j,3);
      r  = y                        + 1.402   * (cr - 128);
      g  = y - 0.34414 * (cb - 128) - 0.71414 * (cr - 128);
      b  = y + 1.772   * (cb - 128);
      z(i,j,1) = r;
      z(i,j,2) = g;
      z(i,j,3) = b;
    end
  end
end
