mss_config('default_solver', 'z3');

% We construct a venn-diagram like view with:
%     a || circ_1 /\ circ_2                     % a || p1
%       &&
%     b || circ_3 /\ circ_4                     % b || p2
%       &&
%     c || circ_5 /\ circ_6 /\ circ_7           % c || p3
%       &&
%     a + b + c < 3
%
% Where the intersecting circles are [1, 4], [3, 2], [5,6,7]

a = symbolic('a', 'logical');
b = symbolic('b', 'logical');
c = symbolic('c', 'logical');

x = symbolic('x', 'real');
y = symbolic('y', 'real');

c1 = (x-10)^2 + (y-0)^2 - 1 <= 0;
c2 = (x-5)^2 + (y-0)^2 - 1 <= 0;
c3 = (x-4)^2 + (y-0)^2 - 1.5 <= 0;
c4 = (x-9.5)^2 + (y-0)^2 - 1 <= 0;
c5 = (x - 0)^2 + (y - 0)^2 - 9 <= 0;
c6 = (x - 0)^2 + (y - 0)^2 - 1 <= 0;
c7 = (x - 0)^2 + (y - 1)^2 - 1.5 <= 0;

s = 3;

[isSAT m] = check_sat( (a || (c1 && c2)) && (b || (c3 && c4)) && (c || (c5 && c6 && c7)) && (a + b + c < s))
