
% 2D euclidian space
x = symbolic('x','real');
y = symbolic('y','real');


% 6 circles... do they overlap?
circle1 = ((x-2)^2 + (y-2)^2 - 4);
circle2 = ((x-3)^2 + (y)^2 - 3);
circle3 = ((x)^2 + (y-2)^2 - 16);
circle4 = ((x)^2 + (y)^2 - 2);
circle5 = ((x)^2 + (y+1)^2 - 2);
circle6 = ((x+3)^2 + (y+2)^2 - 2);

% Construct the fesibility problem using slack space for each circle
% s1 = symbolic('s1','real');
% s2 = symbolic('s2','real');
% s3 = symbolic('s3','real');
% s4 = symbolic('s4','real');
% s5 = symbolic('s5','real');
% s6 = symbolic('s6','real');
s = symbolic('s','real');

% % Subtract the slack space, recall convex_opt constraints are implicitly f <= 0.
% fc1 = circle1 - s1;
% fc2 = circle2 - s2;
% fc3 = circle3 - s3;
% fc4 = circle4 - s4;
% fc5 = circle5 - s5;
% fc6 = circle6 - s6;
% obj = s1+s2+s3+s4+s5+s6;
fc1 = circle1 - s;
fc2 = circle2 - s;
fc3 = circle3 - s;
fc4 = circle4 - s;
fc5 = circle5 - s;
fc6 = circle6 - s;
obj = s;

% If we find an obj=0 then the circles overlap.

% 1. We are minimizing our slack space by minimizing 'obj'.  If this reaches
%    zero then all the constraints are feasible.
% 2. All our slack-included constraints must be satisifed
% 3. The slack variables must always be non-negative (-slack <= 0)
% [sat model] = convex_opt(obj, [fc1,fc2,fc3,fc4,fc5,fc6,-s1,-s2,-s3,-s4,-s5,-s6])
[sat model] = convex_opt(obj, [fc1,fc2,fc3,fc4,fc5,fc6,-s])

% Recall this is an approximation algorithm, so we need to verify the final points...
% probablyOverlap = sat && (model.s1 + model.s2 + model.s3 + model.s4 + model.s5 + model.s6 < 0.001)
probablyOverlap = sat && (model.s < 0.001)

if(probablyOverlap)
    % eval( (circle1 <= 0) && (circle2 <= 0) && (circle3 <= 0) && (circle4 <= 0), model)
    % Can not confirm overlap: No evaluation function in mss as of Alpha 31.
    % Using Z3 as an evaluator
    mss_config('default_solver','z3')
    does_overlap_at_model = check_sat( (circle1 <= 0) && (circle2 <= 0) && (circle3 <= 0) && (circle4 <= 0) && (circle5 <= 0) && (circle6 <= 0) && x == model.x && y == model.y)

end
