% This file describe the problem of finding a glider that moves
% from one state to another.
function [] = wall

% Define constraints for problem
% These functions are defined at the bottom of the file.
[start_state,end_state] = small_problem
%[start_state,end_state] = big_problem

max_iter = 40;

% These define different ways of encoding Conway's game of file.
conway = @conway_bit;


% Create symbolic variables for garden of eden.
x = symbolic('x', size(start_state), 'logical')

c0 = sat_constraints(x, start_state)

total = 0;
y = x;
for i = 1:max_iter
  i
  y = conway(y);
  c1 = sat_constraints(y, end_state);

  %  write_smtlib2(['wall' num2str(i)  '.smt2'], c0 & c1)

  start = clock;
  [r,s] = check_sat(c0 & c1);
  diff = etime(clock, start)
  total = total + diff;

  r
  if r
    write_yices('wall_final.yices', c0 & c1)
    total
    s.x
    rep(conway, i, s.x)
    break;
  end
end

end

% This function defines a small problem that
% can be solved in a minimum of 10 steps.
function [start_state,end_state] = small_problem
start_state = [
  '______0000000'
  '______0110000'
  '______0110000'
  '______0000000'
  '______0110000'
  '______0110000'
  '______0000000'
]


end_state = [
  '0000000000___'
  '0000000110___'
  '0000000110___'
  '0000000000__1'
  '0000000110___'
  '0000000110___'
  '0000000000___'
]
end

% This function defines a larger problem that
% is still open.
function [start_state,end_state] = big_problem

start_state = [
  '______000000000'
  '______011000000'
  '______011000000'
  '______000000000'
  '______011000000'
  '______011000000'
  '______000000000'
  '______011000000'
  '______011000000'
  '______000000000'
]


end_state = [
  '0000000000_____'
  '0000000110_____'
  '0000000110____1'
  '0000000000_____'
  '0000000110_____'
  '0000000110_____'
  '0000000000_____'
  '0000000110____1'
  '0000000110_____'
  '0000000000_____'
]
end