% The Boyer-Moore majority vote finding algorithm MJRTY.  If the array
% 'x' has a value occuring in a strict majority of the positions, that
% value will be returned.  If no value has a strict majority, an
% arbitrary value will be returned which depends on the order of the
% elements in the array.
function c = find_majority(x)

n = 0;

for i = 1:length(x)
    if n == 0
        n = 1;
        c = x(i);
    elseif x(i) == c
        n = n + 1;
    else
        n = n - 1;
    end
end

end
