#include <stdio.h>
#include <sym-api.h>

const int sz = 11;

int find_majority( int* arr, int n );

int main()
{
  int* arr = (int*) mss_fresh_uint32_array( "x", sz );

  // Assume that 'maj' is the majority element
  int maj = mss_fresh_uint32( "maj" );
  int count = 0;
  for( int i=0; i<sz; i++ ) {
    if( maj == arr[i] ) { count++; }
  }
  mss_assume( (2*count) > sz );

  // Call the algorithm
  int c = find_majority( arr, sz );
  mss_assert( c == maj );

  uint32_t num = mss_prove_obligations();

  if( num == 0 ) {
    printf("All obligations proved! Verification successful!\n");
  } else {
    printf("Verification could not be completed.  %d goals remaining.\n", num);
  }

  return num;
}
