import matplotlib.pyplot as plt

def makeplot(file) :
  fig, ax = plt.subplots()
  data = getdata(file)
  def select(p,s) :
    return p['name'] == s and p['count'] == 5000 # and p['width'] == 34

  slide = [i['width'] - i['shift'] for i in data if select(i,'tests/slide')]
  # slide = [i['shift'] for i in data if select(i,'tests/slide')]
  tm = [i['time'] for i in data if select(i,'tests/slide')]
  ax.plot(slide,tm,'ro',label='Slide')

  slide_induct = [i['width'] - i['shift'] for i in data if select(i,'tests/slide_induct')]
  # slide_induct = [i['shift'] for i in data if select(i,'tests/slide_induct')]
  tm = [i['time'] for i in data if select(i,'tests/slide_induct')]
  ax.plot(slide_induct,tm,'g^',label='Induct')

  slide_induct_assert = [i['width'] - i['shift'] for i in data if select(i,'tests/slide_induct_assert')]
  # slide_induct_assert = [i['shift'] for i in data if select(i,'tests/slide_induct_assert')]
  tm = [i['time'] for i in data if select(i,'tests/slide_induct_assert')]
  ax.plot(slide_induct,tm,'bs',label='Induct Assert')

  ax.set_xlabel('overlap')
  ax.set_ylabel('time')
  leg = ax.legend()


def getdata(file):
  data = []
  with open(file,'r') as f:
    for line in f:
      columns = line.strip().split()
      if len(columns) == 5:
        rec = {}
        rec['name'] = columns[0]
        rec['count'] = int(columns[1])
        rec['width'] = int(columns[2])
        rec['shift'] = int(columns[3])
        rec['time'] = float(columns[4])
        data.append(rec)
  return data
