% Compute 2D sliding average
% 'width' is the size of the window
% 'shift' is how much to shift the window
% shift must be less than width (ie windows overlap)
function y = slide2d(x,width,shift)
  nx = size(x, 2);
  ny = ceil ((nx-width+1)/shift);
  y = zeros(ny,ny);

  i = 1;
  for p = 1:ny
      j = 1;
      for q = 1:ny
          seg = x( i:(i+width-1), j:(j+width-1) );
          y(p,q) = sum(sum(seg)) / (width*width);
          j = j + shift;
      end
      i = i + shift;
  end
end
